/**
 * ANY.java
 *
 * File generated from the medication::ANY uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class ANY.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ANY", propOrder = {
	"nullFlavor"
})
@XmlRootElement(name = "ANY")
public abstract class ANY extends net.ihe.gazelle.gen.common.CommonOperations {
	

	
	/**
	 *                 An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.             .
	 */
	@XmlAttribute(name = "nullFlavor")
	public net.ihe.gazelle.medication.NullFlavor nullFlavor;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return nullFlavor.
	 * @return nullFlavor :                 An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.             
	 */
	public net.ihe.gazelle.medication.NullFlavor getNullFlavor() {
	    return nullFlavor;
	}
	
	/**
	 * Set a value to attribute nullFlavor.
	 * @param nullFlavor :                 An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.                             An exceptional value expressing missing
	                    information                and possibly the reason why the information is
	                    missing.             .
	 */
	public void setNullFlavor(net.ihe.gazelle.medication.NullFlavor nullFlavor) {
	    this.nullFlavor = nullFlavor;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "ANY").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ANY aNY, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (aNY != null){
   			cvm.validate(aNY, location, diagnostic);
    	}
    }

}